var wpPrefBranch=null;

function trim(input) {
	var s=input;
	try {
		if (s==null || s=="") {
			return "";
		}
		while (s.substring(0,1) == ' ') {
			s = s.substring(1,s.length);
		}
		while (s.substring(s.length-1,s.length) == ' ') {
			s = s.substring(0,s.length-1);
		}
	}
	catch (e) {
	}
	return s;
}

function replace(input, search, replace) {
	output = "" + input;
	while (output.indexOf(search)>-1) {
		pos= output.indexOf(search);
		output = "" + (output.substring(0, pos) + replace + output.substring((pos + search.length), output.length));
	}
	return output;
}

function blankLeft(s) {
	if (s==null || s=="") {
		return "";
	}
	var r="";
	while (s.substring(0,1) == ' ') {
		r=r+s.substring(0,1);
		s = s.substring(1,s.length);
	}
	return r;
}

function blankRight(s) {
	if (s==null || s=="") {
		return "";
	}
	var r="";
	while (s.substring(s.length-1,s.length) == ' ') {
		r = s.substring(s.length-1,s.length);
		s = s.substring(0,s.length-1);
	}
	return r;
}

function formatString(aString, arguments) {
	var result=aString;
	for (i=0;i<arguments.length;i++) {
		var regEx = new RegExp ('%'+(i+1), 'gi') ;
		result = result.replace(regEx, arguments[i]);
	}
	return result;
}

function readFile(str_Filename)
{
	try{
		var obj_File = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		obj_File.initWithPath(str_Filename);
		
		var obj_InputStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
		obj_InputStream.init(obj_File,0x01,0444,null);
		
		var obj_ScriptableIO = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
		obj_ScriptableIO.init(obj_InputStream);
	} catch (e) {
		alert(e);
	}
	
	try {
		var str = obj_ScriptableIO.read(obj_File.fileSize-1);
	} catch (e) {
		dump(e);
	}
	
	obj_ScriptableIO.close();
	obj_InputStream.close();
	return str;
}

function getContentsFromURL(aURL){
	var ioService=Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var scriptableStream=Components.classes["@mozilla.org/scriptableinputstream;1"].getService(Components.interfaces.nsIScriptableInputStream);
	
	var channel=ioService.newChannel(aURL,null,null);
	var input=channel.open();
	scriptableStream.init(input);
	var str=scriptableStream.read(input.available());
	scriptableStream.close();
	input.close();
	return str;
}

function getNodes(url, nodeSelector) {
	var content = getContentsFromURL(url);
	var uConv = Components.classes['@mozilla.org/intl/scriptableunicodeconverter'].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	uConv.charset = "UTF-8";
	var content = uConv.ConvertToUnicode(content);
	var parser = new DOMParser();
	var domtree = parser.parseFromString(content, "text/xml");
	var nodes = document.evaluate(nodeSelector,domtree,null,0,null);
	var nodelist = new Array();
	var xpathnode = nodes.iterateNext();
	while (xpathnode) {
		nodelist.push(xpathnode);
		xpathnode = nodes.iterateNext();
	}
	return nodelist;
}
	
function getPreferences() {
	if (!wpPrefBranch) {
		try {
			var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			wpPrefBranch = prefService.getBranch("wikipedia."); // preferences wikipedia node
			wpPrefBranch.setIntPref("lastversion",70);
		} catch (e) {
			alert(e);
		}
	}
	return wpPrefBranch;
}