const OPTION_ACTIVE_COUNT="active.count";
const OPTION_ACTIVE_URL="active.url";
const OPTION_ACTIVE_LABEL="active.label";
const OPTION_ACTIVE_LANGUAGE="active.language";

const IMAGE_ON="chrome://wikipedia/skin/select_on.gif";
const IMAGE_OFF="chrome://wikipedia/skin/select_off.gif";

var wbPrefs=null;

function onLoadPageUser() {
	parent.initPanel('chrome://wikipedia/content/wikipedia_preferences_user.xul');
	wbPrefs = getPreferences();
	loadStandardWikis();
}

function clickStandardWiki(event)
{
	tree=document.getElementById('tree-standard');
	if (tree.currentIndex>=0) {
		item=tree.view.getItemAtIndex(tree.currentIndex);
		label=item.firstChild.firstChild.nextSibling.getAttribute("label");
		active=item.firstChild.firstChild;
		image=active.getAttribute("src");
		if (image==IMAGE_OFF) {
			active.setAttribute("src",IMAGE_ON);
		}
		else {
			active.setAttribute("src",IMAGE_OFF);
		}
		storeStandardWikis();
	}
}

function addStandardWiki(parentId,code,language,english,url) {
	var wiki_tree=document.getElementById(parentId);
	select_image=IMAGE_OFF;
	var count_active=wbPrefs.getIntPref(OPTION_ACTIVE_COUNT);
	for (i=0;i<count_active;i++) {
		var active_url=wbPrefs.getCharPref(OPTION_ACTIVE_URL+i);
		if (active_url==url) {
			select_image=IMAGE_ON;
		}
	}
	var item=document.createElement('treeitem');
	var row=document.createElement('treerow');
	var cell=document.createElement('treecell');
	cell.setAttribute("src",select_image);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",code);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",language);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",english);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",url);
	row.appendChild(cell);
	item.appendChild(row);
	wiki_tree.appendChild(item);
}

function loadStandardWikis() {
	var projects=['wikipedia','wiktionary','wikibooks','wikiquote','wikisource','wikinews','special'];
	var nodelist = getNodes("chrome://wikipedia/content/wiki_projects.xml","/languages/language");
	for(var i=0; i < nodelist.length; i++) {
		node=nodelist[i];
		var code = document.evaluate("code/text()",node,null,0,null).iterateNext();
		if (code!=null) {
			code = code.nodeValue;
		}
		else {
			code = "";
		}
		var name = document.evaluate("name/text()",node,null,0,null).iterateNext().nodeValue;
		var english = document.evaluate("name_english/text()",node,null,0,null).iterateNext().nodeValue;
		for (p=0;p<projects.length;p++) {
			var url = document.evaluate(projects[p]+"/text()",node,null,0,null).iterateNext();
			if (url!=null) {
				addStandardWiki("projects-"+projects[p],code,name,english,url.nodeValue);
			}
		}
	}
}

function storeStandardWikis() {
	var wiki_count=0;
	wiki_projects=document.getElementById('wiki-projects').childNodes;
	for (project_index=0;project_index<wiki_projects.length;project_index++) {
		project=wiki_projects[project_index].firstChild.nextSibling;
		projectName=wiki_projects[project_index].firstChild.firstChild.getAttribute("label");
		items=project.childNodes;
		for (i=0;i<items.length;i++) {
			image=items[i].firstChild.firstChild.getAttribute('src');
			if (image==IMAGE_ON) {
				code=items[i].firstChild.firstChild.nextSibling.getAttribute("label");
				url=items[i].firstChild.firstChild.nextSibling.nextSibling.nextSibling.nextSibling.getAttribute("label");
				label=projectName+" ("+code+")";
				language=code;
				if (projectName=="Wikimedia") {
					label=items[i].firstChild.firstChild.nextSibling.nextSibling.nextSibling.getAttribute("label");
					language="en";
				}
				wbPrefs.setCharPref(OPTION_ACTIVE_URL+wiki_count,url);
				wbPrefs.setCharPref(OPTION_ACTIVE_LABEL+wiki_count,label);
				wbPrefs.setCharPref(OPTION_ACTIVE_LANGUAGE+wiki_count,language);
				wiki_count++;
			}
		}
	}
	if ((wiki_count==0) && (document.getElementById('projects-user').childNodes.length==0)) {
		//TODO
	}
	wbPrefs.setIntPref(OPTION_ACTIVE_COUNT,wiki_count);
}